import { DependencyClass } from '../classification';
import AST, { SourceFile, ClassDeclaration } from "ts-simple-ast";
export declare class ASTClass extends AST {
    typescript: string;
    javascript: string;
    template: string;
    style: SFCBlock;
    sfc: SFCDescriptor;
    path: string;
    source: SourceFile;
    constructor();
    constructor(path: string);
    readonly name: string;
    private log;
    private toImportDeclaration;
    private processScript;
    transpile(): void;
    load(content: string): void;
    pitch(path: string): void;
    inject(content: string): void;
    injectHMREntry(source: SourceFile): void;
    injectHMRVue(source: SourceFile, depenency: DependencyClass): void;
    mounted(cls: ClassDeclaration): void;
    private codeEventMethods;
    private codeMountedUpdatedMethods;
    private codeCreateMethod;
    addFile(path: string): void;
    static addFile(path: string): void;
}
